import 'package:jwt_decoder/jwt_decoder.dart';
import 'package:nui_core/code/nui_code_util.dart';

class NUIAuthAccessToken{
  NUIAuthAccessToken({this.token, this.refreshToken}){
    Map<String, dynamic> decodedToken = JwtDecoder.decode(token);
    claims = decodedToken;
    payload = decodedToken["user"];
    logNUI("NUIAuthToken", "Claims : $claims, payload: $payload");
  }
  final String token;
  final String refreshToken;
  Map<String, dynamic> claims;
  Map<String, dynamic> payload;

  String getUserId(){
    return claims["sub"];
  }

  bool isExpired({int leeway: 0}){
    int exp = claims["exp"];
    int iat = claims["iat"];
    int todayTime = DateTime.now().millisecondsSinceEpoch;
    int futureToday = todayTime + leeway * 1000;
    int pastToday = todayTime - leeway * 1000;
    bool expValid = exp == null || pastToday <= exp;
    bool iatValid = iat == null || futureToday >= iat;
    return !expValid || !iatValid;
  }
}