import 'package:nui_core/data/nui_ent.dart';
import 'package:nui_geolocator/nui_geolocator.dart';

class NUIUserInfo extends NUIEnt<NUIUserInfo>{
  NUIUserInfo.empty();
  NUIUserInfo({
    this.gender,
    this.dateOfBirth,
    this.latitude,
    this.longitude,
    this.areaCode,
    this.others
  });

  String gender; //Male, Female, other string
  String dateOfBirth; //yyyy-mm-dd
  double latitude;
  double longitude;
  AreaCode areaCode;
  Map<String, dynamic> others; //For other information

  @override
  NUIEntMapper<NUIUserInfo> mapper() => NUIUserInfoEnt();
}

class NUIUserInfoEnt extends NUIEntMapper<NUIUserInfo>{
  @override
  String entityName() => "NUIUserInfo";

  @override
  List<NUIEntField> fields() {
    return [
      NUIEntField<NUIUserInfo>(name: "gender", type: NUIEntType.STRING, setter: (data, value) => data.gender = value, getter: (data) => data.gender),
      NUIEntField<NUIUserInfo>(name: "dateOfBirth", type: NUIEntType.STRING, setter: (data, value) => data.dateOfBirth = value, getter: (data) => data.dateOfBirth),
      NUIEntField<NUIUserInfo>(name: "latitude", type: NUIEntType.DOUBLE, setter: (data, value) => data.latitude = value, getter: (data) => data.latitude),
      NUIEntField<NUIUserInfo>(name: "longitude", type: NUIEntType.DOUBLE, setter: (data, value) => data.longitude = value, getter: (data) => data.longitude),
      NUIEntField<NUIUserInfo>(name: "areaCode", type: NUIEntType.OBJECT, setter: (data, value) => data.areaCode = asObject<AreaCode>(AreaCodeEntity(), value), getter: (data) => data.areaCode),
      NUIEntField<NUIUserInfo>(name: "others", type: NUIEntType.OBJECT, setter: (data, value) => data.others = asMap(value), getter: (data) => data.others),
    ];
  }

  @override
  NUIUserInfo newInstance() => NUIUserInfo.empty();
}